theory ExecuteTPODTrivial
  imports ExecuteTPOD ExecuteTrivial
begin

section \<open>Trivialities under a full execution of TPOD\<close>

text \<open>If speculative traces never mispredict then they are trivially low equivalent. Showing that they must mispredict to catch vulnerabilities\<close>

lemma execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D_ns_low_equiv:
  assumes "execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D \<pi>\<^sub>1 \<pi>\<^sub>2 \<pi>\<^sub>3 \<pi>\<^sub>4"
      and "wfs4_ns (hd \<pi>\<^sub>1) (hd \<pi>\<^sub>2) (hd \<pi>\<^sub>3) (hd \<pi>\<^sub>4)" 
      and "\<not>speculates \<pi>\<^sub>3 \<or> \<not>speculates \<pi>\<^sub>4"
    shows "\<pi>\<^sub>3 \<approx>\<^sub>\<L> \<pi>\<^sub>4"
  using assms execute_ns_wfs_ns_low_equiv execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D_def by blast

lemma execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D_no_mispred_low_equiv:
  assumes "execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D \<pi>\<^sub>1 \<pi>\<^sub>2 \<pi>\<^sub>3 \<pi>\<^sub>4"
      and "wfs4_ns (hd \<pi>\<^sub>1) (hd \<pi>\<^sub>2) (hd \<pi>\<^sub>3) (hd \<pi>\<^sub>4)"
      and "\<not>mispredicts \<pi>\<^sub>3 \<or> \<not>mispredicts \<pi>\<^sub>4"
    shows "\<pi>\<^sub>3 \<approx>\<^sub>\<L> \<pi>\<^sub>4"
  using assms by (meson execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D_def execute_s\<^sub>3_no_mispred_ns_init_implies_speculating execute_s\<^sub>4_no_mispred_ns_init_implies_speculating execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D_ns_low_equiv)

text \<open>Speculative traces never mispredict then they are trivially low equivalent. Showing that they 
      must mispredict to catch vulnerabilities.\<close>

lemma execute4_mispred_implies_all:
  assumes "(execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D \<pi>\<^sub>1 \<pi>\<^sub>2 \<pi>\<^sub>3 \<pi>\<^sub>4 \<and> wfs4_ns (hd \<pi>\<^sub>1) (hd \<pi>\<^sub>2) (hd \<pi>\<^sub>3) (hd \<pi>\<^sub>4) \<and> mispredicts \<pi>\<^sub>3 \<and> mispredicts \<pi>\<^sub>4 \<Longrightarrow> \<pi>\<^sub>3 \<approx>\<^sub>\<L> \<pi>\<^sub>4)"
  shows "(execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D \<pi>\<^sub>1 \<pi>\<^sub>2 \<pi>\<^sub>3 \<pi>\<^sub>4 \<and> wfs4_ns (hd \<pi>\<^sub>1) (hd \<pi>\<^sub>2) (hd \<pi>\<^sub>3) (hd \<pi>\<^sub>4) \<longrightarrow> \<pi>\<^sub>3 \<approx>\<^sub>\<L> \<pi>\<^sub>4)"
proof -
  have "(execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D \<pi>\<^sub>1 \<pi>\<^sub>2 \<pi>\<^sub>3 \<pi>\<^sub>4 \<and> wfs4_ns (hd \<pi>\<^sub>1) (hd \<pi>\<^sub>2) (hd \<pi>\<^sub>3) (hd \<pi>\<^sub>4) \<and> (\<not>mispredicts \<pi>\<^sub>3 \<or> \<not>mispredicts \<pi>\<^sub>4) \<Longrightarrow> \<pi>\<^sub>3 \<approx>\<^sub>\<L> \<pi>\<^sub>4)"
    using execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D_no_mispred_low_equiv by auto
  then show ?thesis
    using assms(1) by auto
qed

end 